<?php



























define('DATE_TIMESTAMP',0);
define('DATE_NOW',1);
define('DATE_YEAR_MONTH_DAY',2);
define('DATE_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND',3);
define('DATE_FROM_STRING',4);
define('DATE_FORMAT_TINY',1);
define('DATE_FORMAT_SHORT',2);
define('DATE_FORMAT',3);
define('DATE_FORMAT_LONG',4);
define('DATE_RFC822_F',5);
define('DATE_RFC3339_F',6);
define('DATE_FORMAT_TEXT_SHORT',7);
define('DATE_FORMAT_TEXT_LONG',8);
define('DATE_FORMAT_MEDIUM',9);

define('DATE_RFC822_FORMAT','D, d M Y H:i:s O');
define('DATE_RFC3339_FORMAT','Y-m-d\TH:i:s');

define('TIMEZONE_AUTO',TIMEZONE_USER);












class Date
{



private $timestamp=0;








































public function __construct()
{

$num_args=func_num_args();

if($num_args==0)
{
$format=DATE_NOW;
}
else
{
$format=func_get_arg(0);
}

if($format!=DATE_NOW)
{

if($num_args>=2)
{
$referencial_timezone=func_get_arg(1);
}
else
{
$referencial_timezone=TIMEZONE_USER;
}

$time_difference=self::compute_server_user_difference($referencial_timezone);
}

switch($format)
{
case DATE_NOW:
$this->timestamp=time();
break;


case DATE_YEAR_MONTH_DAY:
if($num_args>=5)
{
$year=func_get_arg(2);
$month=func_get_arg(3);
$day=func_get_arg(4);
$this->timestamp=mktime(0,0,0,$month,$day,$year)-$time_difference*3600;
}
else
{
$this->timestamp=0;
}
break;


case DATE_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND:
if($num_args>=7)
{
$year=func_get_arg(2);
$month=func_get_arg(3);
$day=func_get_arg(4);
$hour=func_get_arg(5);
$minute=func_get_arg(6);
$seconds=func_get_arg(7);
$this->timestamp=mktime($hour,$minute,$seconds,$month,$day,$year)-$time_difference*3600;
}
else
{
$this->timestamp=0;
}
break;

case DATE_TIMESTAMP:
if($num_args>=3)
{
$this->timestamp=func_get_arg(2)-$time_difference*3600;
}
else
{
$this->timestamp=0;
}
break;

case DATE_FROM_STRING:
if($num_args<4)
{
$this->timestamp=0;
break;
}
list($month,$day,$year)=array(0,0,0);
$str=func_get_arg(2);
$date_format=func_get_arg(3);
$given_times=explode('/',$str);
$array_date=explode('/',$date_format);
for($i=0;$i<3;$i++)
{
switch($array_date[$i])
{
case 'd':
$day=(isset($given_times[$i]))?NumberHelper::numeric($given_times[$i]):0;
break;

case 'm':
$month=(isset($given_times[$i]))?NumberHelper::numeric($given_times[$i]):0;
break;

case 'y':
case 'Y':
$year=(isset($given_times[$i]))?NumberHelper::numeric($given_times[$i]):0;
break;
}
}


if(self::check_date($month,$day,$year))
{
$this->timestamp=@mktime(0,0,1,$month,$day,$year)-$time_difference*3600;
}
else
{
$this->timestamp=0;
}
break;

default:
$this->timestamp=0;
}
}




















public function format($format=DATE_FORMAT_TINY,$referencial_timezone=TIMEZONE_USER)
{
$timestamp=$this->timestamp+self::compute_server_user_difference($referencial_timezone)*3600;

switch($format)
{
case DATE_FORMAT_TINY:
return date(LangLoader::get_message('date_format_tiny','main'),$timestamp);
break;

case DATE_FORMAT_SHORT:
return date(LangLoader::get_message('date_format_short','main'),$timestamp);
break;

case DATE_FORMAT_MEDIUM:
return date(LangLoader::get_message('date_format_medium','main'),$timestamp);
break;

case DATE_FORMAT:
return date(LangLoader::get_message('date_format','main'),$timestamp);
break;

case DATE_FORMAT_LONG:
return date(LangLoader::get_message('date_format_long','main'),$timestamp);
break;

case DATE_TIMESTAMP:
return $timestamp;
break;

case DATE_RFC822_F:
return date(DATE_RFC822_FORMAT,$timestamp);
break;

case DATE_RFC3339_F:
return date(DATE_RFC3339_FORMAT,$timestamp).(GeneralConfig::load()->get_site_timezone()<0?'-':'+').sprintf('%02d:00',GeneralConfig::load()->get_site_timezone());
break;

case DATE_FORMAT_TEXT_SHORT:
return self::transform_date(date(LangLoader::get_message('date_format_text_short','main'),$timestamp));
break;

case DATE_FORMAT_TEXT_LONG:
return self::transform_date(date(LangLoader::get_message('date_format_text_long','main'),$timestamp));
break;

default:
return '';
}
}





public function get_timestamp()
{
return $this->timestamp;
}






public function get_year($timezone=TIMEZONE_AUTO)
{
return date('Y',$this->get_adjusted_timestamp($timezone));
}

public function set_year($year)
{
$this->set_date_from_values($year,$this->get_month(),$this->get_day(),
$this->get_hours(),$this->get_minutes(),$this->get_seconds());
}






public function get_month($timezone=TIMEZONE_AUTO)
{
return date('m',$this->get_adjusted_timestamp($timezone));
}

public function set_month($month)
{
$this->set_date_from_values($this->get_year(),$month,$this->get_day(),
$this->get_hours(),$this->get_minutes(),$this->get_seconds());
}






public function get_day($timezone=TIMEZONE_AUTO)
{
return(int)date('d',$this->get_adjusted_timestamp($timezone));
}

public function set_day($day)
{
$this->set_date_from_values($this->get_year(),$this->get_month(),$day,
$this->get_hours(),$this->get_minutes(),$this->get_seconds());
}






public function get_hours($timezone=TIMEZONE_AUTO)
{
return date('H',$this->get_adjusted_timestamp($timezone));
}

public function set_hours($hours,$referential_timezone=TIMEZONE_AUTO)
{
$adjusted_hours=$hours+self::compute_server_user_difference($referential_timezone);
$this->set_date_from_values($this->get_year(),$this->get_month(),$this->get_day(),
$adjusted_hours,$this->get_minutes(),$this->get_seconds());
}





public function get_minutes()
{
return date('i',$this->timestamp);
}

public function set_minutes($minutes)
{
$this->set_date_from_values($this->get_year(),$this->get_month(),$this->get_day(),
$this->get_hours(),$minutes,$this->get_seconds());
}





public function get_seconds()
{
return date('s',$this->timestamp);
}

public function set_seconds($second)
{
$this->set_date_from_values($this->get_year(),$this->get_month(),$this->get_day(),
$this->get_hours(),$this->get_minutes(),$second);
}





public function to_date()
{
return date('Y-m-d',$this->timestamp);
}






public function is_anterior_to(Date $date)
{
return $this->timestamp<$date->timestamp;
}






public function is_posterior_to(Date $date)
{
return!$this->is_anterior_to($date);
}






public function equals(Date $date)
{
return $this->timestamp==$date->timestamp;
}







private static function check_date($month,$day,$year)
{
return checkdate($month,$day,$year);
}





private static function compute_server_user_difference($referencial_timezone=TIMEZONE_SYSTEM)
{

$server_hour=self::get_server_timezone()-self::get_offset_due_to_daylight_saving_time();

switch($referencial_timezone)
{

case TIMEZONE_SITE:
$timezone=GeneralConfig::load()->get_site_timezone()-$server_hour;
break;


case TIMEZONE_SYSTEM:
$timezone=0;
break;

case TIMEZONE_USER:
$timezone=AppContext::get_current_user()->get_timezone()-$server_hour;
break;

default:
$timezone=0;
}
return $timezone;
}

private static function get_server_timezone()
{
return intval(date('Z')/3600);
}

private static function get_offset_due_to_daylight_saving_time()
{
return intval(date('I'));
}

private function set_date_from_values($year,$month,$day,$hours,$minutes,$seconds)
{
$this->timestamp=mktime($hours,$minutes,$seconds,$month,$day,$year);
}

private function get_adjusted_timestamp($timezone)
{
return $this->timestamp+self::compute_server_user_difference($timezone)*3600;
}

public static function set_default_timezone()
{
$default=@date_default_timezone_get();
@date_default_timezone_set($default);
}

private static function transform_date($date)
{
$date_lang=LangLoader::get('date-common');

$search=array(
'january','february','march','april','may','june','july','august','september','october','november','december',
'monday','tuesday','wednesday','thursday','friday','saturday','sunday'
);
$replace=array(
$date_lang['january'],$date_lang['february'],$date_lang['march'],$date_lang['april'],$date_lang['may'],$date_lang['june'],
$date_lang['july'],$date_lang['august'],$date_lang['september'],$date_lang['october'],$date_lang['november'],$date_lang['december'],
$date_lang['monday'],$date_lang['tuesday'],$date_lang['wednesday'],$date_lang['thursday'],$date_lang['friday'],$date_lang['saturday'],$date_lang['sunday'],
);
return str_replace($search,$replace,strtolower($date));
}
}
?>